typedef struct _IjsServerCtx IjsServerCtx;

typedef struct {
  int n_chan;        /* number of channels */
  int bps;           /* bits per sample, one of 1, 2, 4, 8, 16 */
  IjsColorSpace cs;
  int width;         /* in pixels */
  int height;
  int xres;          /* in dpi */
  int yres;
} IjsPageHeader;

typedef int IjsSetParamCb (void *set_cb_data,
			   IjsServerCtx *ctx,
			   const char *key,
			   const char *value,
			   int value_size);

typedef int IjsGetParamCb (void *get_cb_data,
			   IjsServerCtx *ctx,
			   const char *key,
			   char *val_buf,
			   int val_size);

IjsServerCtx *
ijs_server_init (void);

int
ijs_server_install_set_cb (IjsServerCtx *ctx,
			   IjsSetParamCb *set_cb, void *set_cb_data);

int
ijs_server_install_get_cb (IjsServerCtx *ctx,
			   IjsSetParamCb *get_cb, void *get_cb_data);

void
ijs_server_done (IjsServerCtx *ctx);

int
ijs_server_iter (IjsServerCtx *ctx);

int
ijs_server_get_page_header (IjsServerCtx *ctx, IjsPageHeader *ph);

int
ijs_server_get_data (IjsServerCtx *ctx, char *buf, int size);

